/**
 * 
 */
package com.platomix.userprofile.handler.support;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.io.IoUtil;
import com.platomix.userprofile.enums.DsEnum;
import com.platomix.userprofile.service.DynamicExecuteService;
import com.platomix.userprofile.service.MobileRangeService;
import com.platomix.userprofile.utils.StrBuilder;
import com.platomix.userprofile.utils.TagKit;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.nio.charset.Charset;
import java.util.*;
import java.util.concurrent.TimeUnit;

/**
 * @author felix
 * 信息化数据处理 帮助类
 */
@Slf4j
@Component
public class XxhTagManager {

	final static String ETL_TABLE_NAME = "ads.XXH_ALL_MONTH_ETL2";
	@Autowired
	protected DynamicExecuteService dynamicExecuteService;

	@Autowired
	private MobileRangeService mobileRangeService;

	final static long _STEP=17000000L;
	/**
	 * 从etl表向 xxh表转化 转化时 重复消除重复
	 * @param month 月份
	 */
	private void xxhFromEtl(String month, String mobileLeft, String mobileRight) {
		String lrMobileSql = mobileLeft == null || mobileRight == null ? "" : String.format(" and DEVICE_NUMBER>='%s' and DEVICE_NUMBER<'%s'", mobileLeft, mobileRight);
		StrBuilder sqlBuilder = new StrBuilder();
		sqlBuilder.appendLn("insert into ads.XXH_ALL_MONTH")
			    .appendLn("select distinct MONTH_ID, SEARCH_FLAG, DEVICE_NUMBER, PROV_DESC, UPPER(SERVICE_TYPE) as SERVICE_TYPE, toUInt32OrZero(INNET_MONTHS) INNET_MONTHS, CUST_SEX, CERT_AGE,")
				.appendLn("TOTAL_FLUX, TOTAL_FEE, ifNull(MON_TOTAL_FEE,'0') AS MON_TOTAL_FEE, PRODUCT_CLASS_DESC, null as MON_FEE, FLUX_M, RESOURCE_NAME,")
				.appendLn("PKG_NAME, MANU_NAME, MODEL_NAME, IS_ACCT ,TOTAL_FLUX_VIDEO, AREA as ARAE")
				.appendLn(String.format("from %s",ETL_TABLE_NAME))
				.appendLn("where MONTH_ID ='"+month+"'" + lrMobileSql)
				.appendLn(String.format("and DEVICE_NUMBER not in (SELECT DEVICE_NUMBER from ads.XXH_ALL_MONTH where MONTH_ID ='%s' and SEARCH_FLAG in('b','B')  %s)",month,lrMobileSql));
		log.info("\n" + sqlBuilder.toString());
		dynamicExecuteService.execute(DsEnum.clickhouse, sqlBuilder.toString(), "ETL导入数据转化为XXH基础数据1");

		StrBuilder sqlBuilderApp = new StrBuilder();
		sqlBuilderApp.appendLn("insert into ads.XXH_ALL_APP_MONTH")
				.appendLn("select MONTH_ID,DEVICE_NUMBER, APP_PRE, CON_PRE, APP_NAME, Max(toUInt32OrZero(DAYS)) as DAYS,")
				.appendLn("toUInt32OrZero(TIMES) as TIMES, toUInt32OrZero(MINS) as MINS, toFloat64OrZero(ONE_FLUX) as ONE_FLUX")
				.appendLn("from ")
				.appendLn("( select MONTH_ID,DEVICE_NUMBER, APP_PRE, CON_PRE, APP_NAME, DAYS,TIMES,MINS,ifNull(ONE_FLUX,'0') as  ONE_FLUX")
				.appendLn("from  "+ETL_TABLE_NAME+" where MONTH_ID ='"+month+"'" + lrMobileSql)
				.appendLn(String.format("and DEVICE_NUMBER not in (SELECT DEVICE_NUMBER from ads.XXH_ALL_MONTH where MONTH_ID ='%s' and SEARCH_FLAG in('b','B')  %s)",month,lrMobileSql))
				.appendLn(") s")
				.appendLn("group by MONTH_ID,DEVICE_NUMBER, APP_PRE, CON_PRE, APP_NAME, TIMES, MINS, ONE_FLUX");
		log.info("\n" + sqlBuilderApp.toString());
		dynamicExecuteService.execute(DsEnum.clickhouse, sqlBuilderApp.toString(), "ETL导入数据转化为XXH基础数据2");


	}
	
	/**
	 * 从etl表向 xxh表转化
	 * @param month 月份
	 */
	public void xxhFromEtlSp(String month) {
		SortedSet<String> mobileList = mobileRangeService.getList(MobileRangeService.DEFAULT_STEP);
		String mobileLeft = mobileList.first();
		for(Iterator<String> it = mobileList.iterator(); it.hasNext(); ) {
			String mobileRight = it.next();
			if(mobileLeft.equals(mobileRight)) {
				continue;
			}
			xxhFromEtl(month, mobileLeft, mobileRight);
			mobileLeft = mobileRight;
		}
	}

	/**
	 * 删除表！！！
	 */
	public void deleteTables() {
		String listStr=
				"LINSHI_SXX_GUANGDONG\n" +
				"LINSHI_SXX_ORDERCHANNEL\n" +
				"LINSHI_SXX_ORDERCHANNEL\n" +
				"LINSHI_TO_SHUKE_MD5\n" +
				"LINSHI_YAQI_XUQIU\n" +
				"LINSHI_YAQI_XUQIU2\n" +
				"LINSHI_YOUXIAO_RSA\n" +
				"LINSHI_hunan_QD\n" +
				"LINSHI_hunan_QD_2\n" +
				"MINGXI_B_202111\n" +
				"TMP_ORDER_PRE_TX_1\n" +
				"TMP_ORDER_PRE_TX\n" +
				"XXH_ALL_APP_MONTH_ALL\n" +
				"XXH_ALL_APP_MONTH_bak\n" +
				"XXH_ALL_APP_MONTH_clu\n" +
				"XXH_ALL_MONTH_ETL_test\n" +
				"XXH_ALL_MONTH_bak\n" +
				"XXH_ALL_MONTH_clu\n" +
				"XXH_ALL_MONTH_test\n" +
				"XXH_APP_temp\n" +
				"XXH_APP_temp2\n" +
				"XXH_USERS_XINZENG09\n" +
				"XXH_XINZENG09_APP_temp\n" +
				"XXH_XINZENG09_APP_temp2\n" +
				"ALS_XXH_CANCEL_NEW_C1\n" +
				"ALS_XXH_CANCEL_NEW_C2\n" +
				"ALS_XXH_CANCEL_NEW_C3\n" +
				"ALS_XXH_CANCEL_NEW_C3_dxflow_lowDim\n" +
				"ALS_XXH_CANCEL_RESULT_base_dataC3_dxflow_low_e200\n" +
				"ALS_XXH_CANCEL_RESULT_base_dataC3_low_e200\n" +
				"ALS_XXH_CANCEL_RESULT_base_dataC3_low_spid6_e300\n" +
				"ALS_XXH_CANCEL_RESULT_base_dataC3_low_spid979_e300\n" +
				"ALS_XXH_CANCEL_RESULT_base_embed_data1\n" +
				"ALS_XXH_CANCEL_RESULT_base_embed_data2\n" +
				"ALS_XXH_CANCEL_RESULT_base_permodel_embed_data1\n" +
				"ALS_XXH_CANCEL_RESULT_deepcross_embed_data1\n" +
				"DW_SXX_202222\n" +
				"DW_SXX_202224\n" +
				"DW_SXX_2022242\n" +
				"DW_SXX_2022243\n" +
				"DW_SXX_2022244\n" +
				"DW_SXX_NMG_220401\n" +
				"DW_SXX_NMG_JIEGUO\n" +
				"DW_XXH_CANCEL_NEW\n" +
				"ETL_LTYG_HMD\n" +
				"ETL_TD_ORDER_RELATIONS\n" +
				"ETL_TD_ORDER_RELATIONS_ALL\n" +
				"ETL_TD_ORDER_RELATIONS_MONTH\n" +
				"ETL_TD_ORDER_RELATIONS_YEAR_ALL\n" +
				"ETL_TD_ORDER_RELATIONS_YEAR_T1\n" +
				"ETL_TD_ORDER_RELATIONS_YEAR_clu\n" +
				"ETL_TD_ORDER_RELATIONS_clu\n" +
				"ETL_TL_VIP_LOG_ALL\n" +
				"ETL_TL_VIP_LOG_clu\n" +
				"HIS_FLOW_ORDER_ALL\n" +
				"HIS_FLOW_ORDER_RSA_ENCODED_20220602\n" +
				"HIS_FLOW_ORDER_clu\n" +
				"HIS_FLOW_ORDER_test\n" +
				"TD_DXFLOWINPUT_MONTH_ALL\n" +
				"TD_DXFLOWINPUT_MONTH_clu\n" +
				"Z_USER_TAG_FLAT_temp_dev_202204\n" +
				"USER_ORDER_CANCEL_TEMP\n" +
				"V_USER_ORDER_CANCEL_TEMP\n" +
				"temp_return_respond\n" +
				"temp_user_map\n" +
				"temp_userid_map\n" +
				"z_user_uuid_temp_202106_202108\n" +
				"ztemp_relation_users" ;
	    String[] s1=listStr.split("\\n");
		Arrays.stream(s1).forEach(str-> {
//			if (str.indexOf("_clu") > 0 || str.indexOf("_ALL") > 0)
				log.info("\n" + String.format("drop table if exists ads.%s", str));
				dynamicExecuteService.execute(DsEnum.clickhouse, String.format("drop table if exists %s",str), "");
				try {
					TimeUnit.SECONDS.sleep(2);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}

		});
	}

}
